SystemOrganization addCategory: #'GT-Debugger-EventRecorder'!
SystemOrganization addCategory: 'GT-Debugger-EventRecorder-Base'!
SystemOrganization addCategory: 'GT-Debugger-EventRecorder-Events'!

!GTGoAndInspectBytecodeDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderGoAndInspectBytecodeEvent fromDebugAction: self! !

!GTStepToBytecodeDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderStepToBytecodeEvent fromDebugAction: self! !

!GTGenericStackDebuggerSelectionChanged methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:44'!
asRecorderEvent

	^ GTDebuggerRecorderStackSelectionChangedEvent fromAnnouncement: self! !

!DebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:43'!
asRecorderEvent

	^ GTDebuggerRecorderDebugActionEvent fromDebugAction: self! !

!RunToSelectionDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderRunToSelectionEvent fromDebugAction: self! !

!GLMBrowserClosing methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:45'!
asRecorderEvent

	^ GTDebuggerRecorderClosingEvent fromAnnouncement: self! !

!GTChangeDebuggerAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:48'!
asRecorderEvent

	^ GTDebuggerRecorderChangeDebuggerEvent fromDebugAction: self! !

!GTGlamourWrapperDebuggingAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderGlamourWrapperEvent fromDebugAction: self! !

GTEventCollector subclass: #GTDebuggerEventCollector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Base'!

!GTDebuggerEventCollector commentStamp: 'RogerStebler 3/18/2016 16:04' prior: 0!
I represent a GTEventCollector for GTDebugger application.!

!GTDebuggerEventCollector methodsFor: 'initialization' stamp: 'RogerStebler 3/22/2016 21:58'!
collectDataFrom: aDebugger
	self occupant: aDebugger;
		category: #gtdebugger;
		register;
		linkToDebugger: aDebugger;
		recordDebuggerOpenEventFor: aDebugger.
		
	aDebugger announcer announce: (GTGenericStackDebuggerSelectionChanged forDebugger: aDebugger).! !

!GTDebuggerEventCollector methodsFor: 'initialization' stamp: 'RogerStebler 3/1/2016 18:41'!
initialize
	super initialize.	
	recordedEvents := SharedQueue  new.! !

!GTDebuggerEventCollector methodsFor: 'initialization' stamp: 'RogerStebler 3/28/2016 15:10'!
linkToDebugger: aDebugger

	aDebugger announcer weak when: Announcement send: #recordAnnouncementIgnoreExecuted: to: self! !

!GTDebuggerEventCollector methodsFor: 'events' stamp: 'RogerStebler 3/28/2016 15:10'!
recordAnnouncement: anAnnouncement
	| event |
	Privacy sendDiagnosticsAndUsageData ifFalse: [ ^ self ].
	(anAnnouncement respondsTo: #asRecorderEvent) ifTrue: [	
		event := anAnnouncement asRecorderEvent.
		self add: event.
		GTEventRecorder uniqueInstance announcer announce: (GTDebuggerRecorderEventRecorded forEvent: event). ]! !

!GTDebuggerEventCollector methodsFor: 'events' stamp: 'RogerStebler 3/28/2016 15:10'!
recordAnnouncementIgnoreExecuted: anAnnouncement
	(anAnnouncement class ~= DebugActionExecuted) ifTrue: [ self recordAnnouncement: anAnnouncement ]! !

!GTDebuggerEventCollector methodsFor: 'events' stamp: 'RogerStebler 3/18/2016 15:46'!
recordDebuggerOpenEventFor: aDebugger
	| event |
	Privacy sendDiagnosticsAndUsageData ifFalse: [ ^ self ].
	event := GTDebuggerRecorderOpenEvent new fromDebugger: aDebugger.
	self add: event.
	GTEventRecorder uniqueInstance announcer announce: (GTDebuggerRecorderEventRecorded forEvent: event).! !

Announcement subclass: #GTDebuggerRecorderEventRecorded
	instanceVariableNames: 'recordedEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Base'!

!GTDebuggerRecorderEventRecorded commentStamp: 'RogerStebler 3/18/2016 16:26' prior: 0!
I am an event that is sent after an action in the debugger was recorded.!

!GTDebuggerRecorderEventRecorded class methodsFor: 'instance creation' stamp: 'RogerStebler 3/1/2016 17:48'!
forEvent: aRecorderEvent
	^ self new
		recordedEvent: aRecorderEvent;
		yourself.! !

!GTDebuggerRecorderEventRecorded methodsFor: 'accessing' stamp: 'RogerStebler 3/1/2016 17:50'!
recordedEvent
	^ recordedEvent! !

!GTDebuggerRecorderEventRecorded methodsFor: 'accessing' stamp: 'RogerStebler 3/1/2016 17:50'!
recordedEvent: aRecorderEvent
	recordedEvent := aRecorderEvent! !

!GTRunToSelectionDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderGTRunToSelectionEvent fromDebugAction: self! !

!MessageSendDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderMessageSendEvent fromDebugAction: self! !

!DebugActionExecuted methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/11/2016 13:54'!
asRecorderEvent

	^ (debuggingAction asRecorderEvent fromAnnouncement: self)
		isExecuted: true;
		yourself! !

Object subclass: #GTDebuggerRecorderEvent
	instanceVariableNames: 'timestamp info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderEvent commentStamp: 'RogerStebler 3/18/2016 16:28' prior: 0!
I am the root class for representing usage data generated by GTDebugger. 
All events have a timestamp.!

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderClosingEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderClosingEvent commentStamp: 'RogerStebler 3/18/2016 16:29' prior: 0!
I model the action of closing the debugger.!

!GTDebuggerRecorderClosingEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/15/2016 16:10'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	
	self addWindowHashFor: anAnnouncement presentation.! !

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderDebugActionEvent
	instanceVariableNames: 'isExecuted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderDebugActionEvent commentStamp: 'RogerStebler 3/18/2016 16:31' prior: 0!
I model the debugging actions in the debugger.!

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderChangeDebuggerEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderChangeDebuggerEvent commentStamp: 'RogerStebler 3/18/2016 16:50' prior: 0!
I model the debugging action of changing the debugger (e.g. stack debugger <-> bytecode debugger).

Corresponding debug action:
GTChangeDebuggerAction!

!GTDebuggerRecorderChangeDebuggerEvent methodsFor: 'private' stamp: 'RogerStebler 3/5/2016 16:02'!
addNewWindowHashFor: aPresentation

	aPresentation window ifNotNil: [ :aWindow |
		self infoAt: #newWindowHash put: aWindow identityHash ]! !

!GTDebuggerRecorderChangeDebuggerEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 14:05'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	aDebugAction newDebugger isNotNil ifTrue: [ self addNewWindowHashFor: aDebugAction newDebugger ]! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderCodeDebugActionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderCodeDebugActionEvent commentStamp: 'RogerStebler 3/18/2016 16:45' prior: 0!
I model the debugging action of selecting an action in the code pane of the debugger.

Corresponding debug action:
GTCodeDebugAction!

!GTDebuggerRecorderCodeDebugActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/12/2016 14:40'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger selectionInterval.! !

!GTDebuggerRecorderDebugActionEvent class methodsFor: 'instance creation' stamp: 'RogerStebler 3/15/2016 15:52'!
fromDebugAction: aDebugAction

	^ self new fromDebugAction: aDebugAction! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'accessing' stamp: 'RogerStebler 2/29/2016 15:11'!
asDebugActionFor: aDebugger
	| actionClass |
	actionClass := (info at: #debugActionClass) asSymbol asClass.
	(actionClass respondsTo: #gtGlobalDebuggingActionFor:) ifTrue: [
		^ actionClass gtGlobalDebuggingActionFor: aDebugger ].
	^ nil! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'initialization' stamp: 'AndreiChis 3/23/2016 14:49'!
fromDebugAction: aDebugAction
	self infoAt: #debugActionClass put: aDebugAction class name.
	self infoAt: #methodClass putHashForText: aDebugAction currentContext methodClass name.
	self infoAt: #methodSelector putHashForText: aDebugAction currentContext methodSelector.
	self infoAt: #pc put: aDebugAction currentContext pc.
	self infoAt: #nextInstruction putHashForText: aDebugAction currentContext peekInstruction asString.
	self addWindowHashFor: aDebugAction debugger.! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/5/2016 15:17'!
isAboutToExectute
	^ self isExecuted not! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/4/2016 14:58'!
isActionForClass: aClassName Method: aMethodName PC: anInteger
	((self infoAt: #methodClass) == aClassName) ifFalse: [ ^ false ].
	((self infoAt: #methodSelector) == aMethodName) ifFalse: [ ^ false ].
	((self infoAt: #pc) == anInteger) ifFalse: [ ^ false ].
	^ true.! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/7/2016 16:25'!
isActionForContext: aContext
	^ self isActionForClass: aContext methodClass name Method: aContext methodSelector PC: aContext pc.! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/11/2016 13:53'!
isExecuted
	^ isExecuted! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/11/2016 13:53'!
isExecuted: aBoolean
	isExecuted := aBoolean! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderGTRunToSelectionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderGTRunToSelectionEvent commentStamp: 'RogerStebler 3/18/2016 16:46' prior: 0!
I model the Run To Selection debugging action in a GTDebugger.

Corresponding debug action:
GTRunToSelectionDebugAction!

!GTDebuggerRecorderGTRunToSelectionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 18:44'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger selectionInterval.! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderGlamourWrapperEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderGlamourWrapperEvent commentStamp: 'RogerStebler 3/18/2016 16:52' prior: 0!
I model the wrapped glamour actions in a GTDebugger.

Corresponding debug action:
GTGlamourWrapperDebuggingAction!

!GTDebuggerRecorderGlamourWrapperEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 17:54'!
fromDebugAction: aDebugAction
	self flag: 'Find a better way to get type of action'.
	super fromDebugAction: aDebugAction.
	self infoAt: #glamourActionTitle put: aDebugAction asGlamourAction title.! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderGoAndInspectBytecodeEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderGoAndInspectBytecodeEvent commentStamp: 'RogerStebler 3/18/2016 16:54' prior: 0!
I model the Go and Inspect debugging action in a GTBytecodeDebugger.

Corresponding debug action:
GTGoAndInspectBytecodeDebugAction!

!GTDebuggerRecorderGoAndInspectBytecodeEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/12/2016 14:50'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger bytecodePresentation selection.! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderMessageSendEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderMessageSendEvent commentStamp: 'RogerStebler 3/18/2016 16:57' prior: 0!
I model the debugging actions that send a message to a receiver in the debugger.

Corresponding debug action:
MessageSendDebugAction!

!GTDebuggerRecorderMessageSendEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 18:24'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selector put: aDebugAction selector.! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderRunToSelectionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderRunToSelectionEvent commentStamp: 'RogerStebler 3/18/2016 16:47' prior: 0!
I model the Run To Selection debugging action in a debugger.

Corresponding debug action:
RunToSelectionDebugAction!

!GTDebuggerRecorderRunToSelectionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 18:44'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger code getSelection.! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderStepToBytecodeEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderStepToBytecodeEvent commentStamp: 'RogerStebler 3/18/2016 16:59' prior: 0!
I model the Step to bytecode debugging action in a GTBytecodeDebugger.

Corresponding debug action:
GTStepToBytecodeDebugAction!

!GTDebuggerRecorderStepToBytecodeEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/12/2016 14:50'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger bytecodePresentation selection.! !

!GTDebuggerRecorderEvent class methodsFor: 'instance creation' stamp: 'AndreiChis 1/29/2016 14:28'!
fromAnnouncement: anAnnouncement

	^ self new fromAnnouncement: anAnnouncement! !

!GTDebuggerRecorderEvent methodsFor: 'comparing' stamp: 'RogerStebler 3/18/2016 18:29'!
= otherGTDebuggerRecorderEvent
	^ (self info = otherGTDebuggerRecorderEvent info)! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'AndreiChis 1/29/2016 15:36'!
addWindowHashFor: aPresentation

	aPresentation window ifNotNil: [ :aWindow |
		self infoAt: #windowHash put: aWindow identityHash ]! !

!GTDebuggerRecorderEvent methodsFor: 'initialization' stamp: 'AndreiChis 1/29/2016 14:28'!
fromAnnouncement: anAnnouncement
! !

!GTDebuggerRecorderEvent methodsFor: 'comparing' stamp: 'RogerStebler 3/18/2016 18:34'!
hash
	^ self info hash! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:42'!
hashForText: aString
	^ self settings obfuscateIfNecessary: aString! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/18/2016 18:28'!
info
	^ info ifNil: [ info := Dictionary new ].! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/3/2016 17:21'!
infoAt: aSymbol
	^ info at: aSymbol! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 17:23'!
infoAt: key ifAbsent: absentBlock
	info ifNil: [ ^ absentBlock value].
	^ info at: key ifAbsent: absentBlock! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 17:23'!
infoAt: key ifAbsentPut: putBlock
	info ifNil: [ info := Dictionary new ].
	^ info at: key ifAbsentPut: putBlock! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 17:23'!
infoAt: key ifPresent: presentBlock ifAbsent: absentBlock
	info ifNil: [ ^ absentBlock value].
	^ info at: key ifPresent: presentBlock ifAbsent: absentBlock! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'AndreiChis 1/29/2016 14:42'!
infoAt: key put: value
	info ifNil: [ info := Dictionary new ].
	^ info at: key put: value! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:43'!
infoAt: key putHashForText: valueString 
	^ self 
		infoAt: key 
		put: (self hashForText: valueString)! !

!GTDebuggerRecorderEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/10/2016 18:04'!
initialize
	super initialize.
	timestamp := DateAndTime now.! !

!GTDebuggerRecorderEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/17/2016 16:16'!
initializeObfuscated
	self obfuscated: Privacy sendEntityNames not.! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:15'!
obfuscated
	^ self infoAt: #obfuscated ifAbsent: true! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:15'!
obfuscated: aBoolean
	^ self infoAt: #obfuscated put: aBoolean! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:51'!
settings
	^ GlobalIdentifier uniqueInstance! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/10/2016 18:05'!
timestamp
	^ timestamp! !

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderOpenEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderOpenEvent commentStamp: 'RogerStebler 3/18/2016 16:30' prior: 0!
I model the action of opening the debugger.!

!GTDebuggerRecorderOpenEvent class methodsFor: 'instance creation' stamp: 'RogerStebler 3/15/2016 15:49'!
fromDebugger: aDebugger

	^ self new fromDebugger: aDebugger! !

!GTDebuggerRecorderOpenEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/22/2016 21:13'!
addSourceFor: aDebugger
	(Privacy sendSourceCode and: [ self isTitleAKernelException: aDebugger title ]) ifTrue: [ self infoAt: #source put: aDebugger currentContext sourceCode ].! !

!GTDebuggerRecorderOpenEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/22/2016 20:56'!
addTitleFor: aDebugger
	(Privacy sendEntityNames or: [ self isTitleAKernelException: aDebugger title ]) ifTrue: [ self infoAt: #title put: aDebugger title ].! !

!GTDebuggerRecorderOpenEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/22/2016 21:12'!
fromDebugger: aDebugger

	self infoAt: #debuggerClass put: aDebugger class name.
	self addWindowHashFor: aDebugger.
	self addTitleFor: aDebugger.
	self addSourceFor: aDebugger.! !

!GTDebuggerRecorderOpenEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/17/2016 16:48'!
initialize
	super initialize.
	self initializeObfuscated.! !

!GTDebuggerRecorderOpenEvent methodsFor: 'private' stamp: 'RogerStebler 3/22/2016 21:09'!
isTitleAKernelException: aString
	^ (#Kernel asPackage classTagNamed: #Exceptions) classes anySatisfy: [ :e | e name == aString asSymbol ]! !

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderStackSelectionChangedEvent
	instanceVariableNames: 'debugger newContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder-Events'!

!GTDebuggerRecorderStackSelectionChangedEvent commentStamp: 'RogerStebler 3/18/2016 16:30' prior: 0!
I model the action of changing the selection in the stack pane of the debugger.!

!GTDebuggerRecorderStackSelectionChangedEvent methodsFor: 'initialization' stamp: 'AndreiChis 3/23/2016 14:53'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	
	self infoAt: #methodClass putHashForText: anAnnouncement newContext methodClass name.
	self infoAt: #methodSelector putHashForText: anAnnouncement newContext methodSelector.
	self infoAt: #pc put: anAnnouncement newContext pc.
	self infoAt: #stackPosition put: anAnnouncement newContext stack size.
	self infoAt: #nextInstruction putHashForText: anAnnouncement newContext peekInstruction asString.
	self addWindowHashFor: anAnnouncement debugger.! !

!GTCodeDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:47'!
asRecorderEvent

	^ GTDebuggerRecorderCodeDebugActionEvent fromDebugAction: self! !

!DebugActionAboutToExecute methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/11/2016 13:54'!
asRecorderEvent

	^ (debuggingAction asRecorderEvent fromAnnouncement: self)
		isExecuted: false;
		yourself! !
